<?php
namespace SM\Controller;

use SM\Controller\SMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use SM\Service\ComposicaoServicosService;
use SM\Traits\TResponse;

class ComposicaoServicosController extends SMCrud
{
    use TResponse;

    protected $ComposicaoServicosService;

    public function __construct($crudService, $environment, ComposicaoServicosService $ComposicaoServicosService)
    {
        parent::__construct($crudService, $environment);
        $this->ComposicaoServicosService = $ComposicaoServicosService;
    }

    public function getComposicaoServicos(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->getComposicaoServicos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function getItComposicaoServico(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->getItComposicaoServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function getServicoOrcaTelaElemento(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->getServicoOrcaTelaElemento($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function getElementoServicoSuperior(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->getElementoServicoSuperior($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }
    
    public function saveComposicaoServicos(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->saveComposicaoServicos($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteComposicaoEmCascata(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->deleteComposicaoEmCascata($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function saveElementoServico(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->saveElementoServico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    } 

    public function saveCadastramentoAutomatico(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->saveCadastramentoAutomatico($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function sincronizarComposicao(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->sincronizarComposicao($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

    public function deleteItemComposicaoEmCascata(Request $request)
    {
        try {
            $data = $this->ComposicaoServicosService->deleteItemComposicaoEmCascata($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(["error" => $ex->getMessage(), "code" => $ex->getCode()], 500);
        }
    }

}