<?php

namespace SM\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use SM\Service\Sm00070000HierarquiaOperadoresService;
use SM\Traits\TResponse;

class Sm00070000HierarquiaOperadoresController
{
    use TResponse;
    
    protected $hierarquiaOperadoresService;

    public function __construct(Sm00070000HierarquiaOperadoresService $hierarquiaOperadoresService)
    {
        $this->hierarquiaOperadoresService = $hierarquiaOperadoresService;
    }

    public function getHierarquiaOperadores()
    {
        try {
            $data = $this->hierarquiaOperadoresService->getHierarquiaOperadores();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function insertHierarquia(DTO\Request $request)
    {
        try {
            $this->hierarquiaOperadoresService->insertHierarquia($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getOperadorHierarquia()
    {
        try {
            $data = $this->hierarquiaOperadoresService->getOperadorHierarquia();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteHierarquia(DTO\Request $request)
    {
        try {
            $this->hierarquiaOperadoresService->deleteHierarquia($request->getParameters());
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
